#include "panel.h"
#include "globals.h"
#include "bargraph.h"

struct bargraph*
bargraph_update(struct bargraph *b, byte val)
{
	byte i, pocet_carek, last_carka, act_carka;
	
	pocet_carek = (b->right - b->left + 1) * 7;
	last_carka = ((word)pocet_carek*(word)b->lastval) >> 8;
	act_carka = ((word)pocet_carek*(word)val) >> 8;

	if (act_carka == last_carka)
		return b;
	
	if (act_carka > last_carka) {
		p_move(last_carka/7 + b->left, b->row);
		for (i = last_carka/7; i < act_carka/7; i++)
			p_putc(4); /* plny blok */
		i = act_carka % 7;
		p_putc(i ? (i == 6 ? 4 : i - 1) : ' ');
	} else {
		p_move(act_carka/7 + b->left, b->row);
		i = act_carka % 7;
		p_putc(i ? (i == 6 ? 4 : i - 1) : ' ');
		for (i = (act_carka/7) + 1; i <= last_carka/7; i++)
			p_putc(' '); /* plny blok */
	}
	b->lastval = val;
	return b;
}
#if 0
struct bargraph*
bargraph_update(struct bargraph *b, byte val)
{
	byte i, pocet_carek, last_carka, act_carka;
	
	pocet_carek = (b->right - b->left + 1) * 6;
	last_carka = ((word)pocet_carek*(word)b->lastval) >> 8;
	act_carka = ((word)pocet_carek*(word)val) >> 8;

	if (act_carka == last_carka)
		return b;
	
	if (act_carka > last_carka) {
		p_move(last_carka/6 + b->left, b->row);
		for (i = last_carka/6; i < act_carka/6; i++)
			p_putc(4); /* plny blok */
		i = act_carka % 6;
		p_putc(i ? (i == 5 ? 4 : i) : ' ');
	} else {
		p_move(act_carka/6 + b->left, b->row);
		i = act_carka % 6;
		p_putc(i ? (i == 5 ? 4 : i) : ' ');
		for (i = (act_carka/6) + 1; i <= last_carka/6; i++)
			p_putc(' '); /* plny blok */
	}
	b->lastval = val;
	return b;
}
#endif 
	
struct bargraph*
bargraph_new(struct bargraph *b, byte left, byte right, byte row)
{
	b->left = left;
	b->right = right;
	b->row = row;
	b->lastval = 255;
	bargraph_update(b, 0);
	
	return b;
}



/* Do CGRAM 0 - 4 hodi znak s jednou carkou, dvema carkama.. 5ti carkama */
void 
bargraph_init(void)
{
	byte chr[8];
	register byte i, tmp;

	tmp = 0;
	for (i = 0; i < 5; i++) {
		tmp |= (1<<(4-i));
		memset(chr, tmp, 8);
		p_programchar(i, chr);
	}
}

struct bargraph *
bargraph_hide(struct bargraph *b)
{
	memset(p_vram[b->row] + b->left, ' ', b->right - b->left + 1);
	p_flushrow(b->row);
	return b;
}

#pragma inline bargraph_show
struct bargraph *
bargraph_show(struct bargraph *b)
{
	return bargraph_refresh(b);
}

struct bargraph *
bargraph_refresh(struct bargraph *b)
{
	register byte tmp = b->lastval;

	memset(p_vram[b->row] + b->left, ' ', b->right - b->left + 1);
	p_flushrow(b->row);
	b->lastval = 0;
	bargraph_update(b, tmp);
	return b;
}

struct bargraph *
bargraph_rupdate(struct bargraph *b, byte val)
{
	b->lastval = val;
	return bargraph_refresh(b);
}
