/*
 * bargraph.h
 *
 * Implementace bargrafu.
 *
 * bargrafy jsou tvoreny z user-programovanych znaku na pozicich 0 - 4,
 * lze nastavit jejich radek, pocatecni a koncovy sloupec. Rozsah je
 * vzdy 0 - 255
 *
 */

#ifndef _BARGRAPH_H_
#define _BARGRAPH_H_

#include "globals.h"

struct bargraph {
	byte left, right;	/* Levy a pravy omezujici znak vcetne */
	byte row;			/* Radek na kterem bargraf je */
	byte lastval;		/* Posledni hodnota */
};

/**
 * val c 0 .. 255
 * @param b bargraf
 * @param val nova hodnota
 * @return ukazatel na bargraf.
 */
struct bargraph*
bargraph_update(struct bargraph *b, byte val);
	
struct bargraph*
bargraph_new(struct bargraph *b, byte left, byte right, byte row);

/**
 * schova bargraf(nahradi mezerama) a pripravi bargraf na
 * volani bargraph_show
 * @param b bargraf ke schovani
 * @return ukazatel na ten samy bargraf
 */
struct bargraph *
bargraph_hide(struct bargraph *b);

/**
 * Obnovi(prevykresli a domezeruje) bargraf schovany volanim
 * bargraph_hide.
 * @param b bargraf k obnoveni
 * @return ukazatel na ten samy bargraf
 */
struct bargraph *
bargraph_show(struct bargraph *b);

/**
 * prekresli cely bargraf(normalne se pri bargraph_update prekresluji
 * pouze zmenene casti)
 * @param b bargraf k obnoveni
 * @return ukazatel na ten samy bargraf
 */
struct bargraph *
bargraph_refresh(struct bargraph *b);

/**
 * Do CGRAM 0 - 4 hodi znak s jednou carkou, dvema carkama.. 5ti carkama 
 * zavolat jednou na zacatku programu.
 */
void 
bargraph_init(void);

/**
 * refresh + update:
 * Do bargrafu b hodi novou hodnotu val a cely ho refreshne.
 * @param b bargraf
 * @param val nova hodnota
 * @return ukazatel na bargraf.
 */
struct bargraph *
bargraph_rupdate(struct bargraph *b, byte val);

#endif /* _BARGRAPH_H_ */
