/*
 * buzzer.h
 *
 * Pipatko. Umoznuje nastavit delku a vysku pipnuti, ma par funkci
 * pro pipnuti pri chybe, potvrzeni atd (kvuli jednotnosti pipani).
 * implementovano pres PPG.
 * 
 */

#ifndef _BUZZER_H_
#define _BUZZER_H_

/* buzzer vyuziva ppgab ch0 pro vypinani piskotu po urcite dobe
 * (parametr duration v fci buzzer()) a ppgabch1 pro generovani
 * piskotu jako takoveho. */

/** buzzer_init
 * dobry zavolat pred jinyma buzzer* fcema */
void
buzzer_init(void);

/** buzzer
 * spusti pipak. 
 * @param duration je doba trvani v setinach sekundy
 * @param pitch -- cim nizsi cislo tim vyssi frekvence. (f ~ 1/(pitch + 1))
 * */
void
buzzer(byte duration, byte pitch);

/** buzzer_ok
 * zapiska OK (kvuli konzistenci piskotu) */
void
buzzer_ok(void);

/** buzzer_error
 * zapiska Error (kvuli konzistenci piskotu) */
void
buzzer_error(void);

/** buzzer_int
 * obsluzna rutina */
__interrupt void
buzzer_int(void);

/** buzzer_volume
 * nastavi hlasitost 
 * @param vol 0 = min, jinak max */
void
buzzer_volume(byte vol);
	
#endif /* _BUZZER_H_ */
