#include "globals.h"
#include "panel.h"
#include "sms.h"
#include "gets.h"
#include "block.h"
#include "debug.h"
#include "rtc.h"
#include "sercntrl.h"

gets_key_filter_func gets_key_filter = default_gets_key_filter;

gets_entry_filter_func gets_entry_filter = default_gets_entry_filter;

byte gets_insert_mode = 1;

enum gets_key_types 
default_gets_key_filter(byte key) 
{
	//const char normal_chars[]="+-.,:?!\"';_*/()<=>%# @&$";
	/* Znaky $, # a > by mohly rusit prenos po seriaku, takze je nechci. */
	const char normal_chars[]="+-.,:?!\"';_*/()<=% @&";
	const char *i;
	
	if ((key >= 'a' && key <= 'z') || (key >= 'A' && key <= 'Z') || 
			(key >= '0' && key <= '9'))
		return gets_normal;

	for (i = normal_chars; *i && *i != key; i++);
	if (*i)
		return gets_normal;
	
	if (key >= K_F1 && key <= K_F5)
		return gets_esc_unget;
	switch (key) {
		case K_ENTER:
		case K_MENU:
		case K_UP:
		case K_DOWN:
		case K_ESC:
			return gets_esc_unget;
		case K_BOX:
			return gets_backspace;
		case K_LEFT:
			return gets_left;
		case K_RIGHT:
			return gets_right;
		default:
			return gets_illegal;
	}
}

byte 
default_gets_entry_filter(char *entry, byte length)
{
	UNUSED_ARG(entry);
	UNUSED_ARG(length);
	return 0;
}

/* Veskere zmeny se provadeji v p_vram, ta se pri gets_enter hodi do buf. */
char *
p_gets(char *buf, byte len)
{
	byte x = p_x;
	byte pos; /* jak daleko je kurzor od zacatku edit. textu ? */
	byte key;
	char *tmp1, *tmp2;

	if (buf) {
			/* prekopiruju buf na displej */
		len = MIN(len, P_COLS - x); /* Text se musi vejit na diplej */
		tmp1 = p_vram[p_y] + x;
		tmp2 = buf;
		pos = 0;
		p_x = x;
		key = *tmp2++;
		while (key != '\0' && pos < len) {
			*tmp1++ = key;
			key = *tmp2++;
			pos++;
		}
		while (pos++ < len)
			*tmp1++ = ' ';
		p_flushrow(p_y);
		p_move(x, p_y);
	}

		/* Dokud se nestiskne nejaka klavesa radsi nic nedelam a 
		 * nechavam si sanci vratit se zpet pri zmene dat ze seriaku */
	pos = 0;
	while((key = p_getkey()) == K_NONE)
		if (sercntrl_cmd != SC_NOTHING)
			return buf;
	p_ungetkey(key);
	
	for(;;) {
		key = p_getsmskey(0);
		switch (gets_key_filter(key)) {
			case gets_left:
				if (pos == 0)
					break;
				pos--; p_x--;
				p_move(p_x, p_y);
				break;
			case gets_right:
				if (pos >= len - 1)
					break;
				pos++; p_x++;
				p_move(p_x, p_y);
				break;
			case gets_backspace:
				if (pos > 0) {
					pos--; p_x--;
					p_move(p_x, p_y);
				}
			case gets_delete:
				memmove(p_vram[p_y] + p_x, p_vram[p_y] + p_x + 1, len - pos - 1);
				p_vram[p_y][x + len - 1] = ' ';
				p_flushrow(p_y);
				break;
			case gets_normal:
				if (pos == len - 1) {
					p_atputc(p_x, p_y, key);
					break;
				}
				if (gets_insert_mode)
					memmove(p_vram[p_y] + p_x + 1, p_vram[p_y] + p_x, len - pos - 1);
				p_vram[p_y][p_x] = key;
				p_flushrow(p_y);
				p_x++; pos++;
				p_move(p_x, p_y);
				break;
			case gets_enter:
				tmp1 = p_vram[p_y] + x;
				if (gets_entry_filter(tmp1, len)) {
					Buzzer(50);
					break;
				}
				if (buf) {
					memcpy(buf, tmp1, len);
					buf[len] = '\0';
				}
			case gets_escape:
				goto finished;
			case gets_esc_unget:
				if (gets_entry_filter(p_vram[p_y]+x, len))
					Buzzer(50);
				p_ungetkey(key);
				goto finished;
			case gets_toggle_insert:
			case gets_illegal:
				break;
		}
	}
finished:
	return buf;
}

char *
p_mvgets(byte x, byte y, char *buf, byte len)
{
	p_move(x, y);
	return p_gets(buf, len);
}
	
