#ifndef _MUTEX_H_
#define _MUTEX_H_

/*
 * Skutecne atomicke mutexy :-)
 * kazdy mutex necht je typu mutex_t (je to obyc. bajt :-)
 * Inicializace se provede makrem MUTEX_INIT(mutex)
 * Blokujici uzamceni makrem MUTEX_LOCK(mutex), tj. kdyz
 * je mutex odemceny, uzamkne jej, pokud je uzamceny,
 * pokousi se mutex uzamknout, dokud jej nekdo neodemkne.
 * K odemknuti mutexu slouzi makro MUTEX_UNLOCK.
 * Neblokujici (pokus o) uzamceni mutexu se provede makrem
 * MUTEX_TRYLOCK(mutex, lab), ktere se pokusi mutex uzamknout,
 * pokud se mu to nepovede (mutex jiz byl uzamcen), skoci na 
 * navesti lab (definuj makrem label()), pokud se povede,
 * pokracuje se dalsim radkem.
 */

typedef volatile unsigned char mutex_t;

#define MUTEX_INIT(mutex) ((mutex) = 0)

#define MUTEX_LOCK(mutex) 					\
__asm(" .repeat");							\
__asm("	MOVN		A, #1");				\
__asm("	XCH 		A, _"#mutex);			\
__asm(" .until.b	(A == #0)");

#define MUTEX_TRYLOCK(mutex,lab) 			\
__asm("	MOVN	A, #1");					\
__asm("	XCH 	A, _"#mutex);				\
__asm(" .if.b 	(A != #0)");				\
__asm(" BRA 	L_"#lab);					\
__asm(" .endif");

#define MUTEX_UNLOCK(mutex)  {(mutex) = 0;}

#endif /* _MUTEX_H_ */ 
