#include <string.h> /* kvuli memset */
#include "globals.h"

/* Changelog: 
 * 2006-10-17: Extraktnuto num2char
 * 2006-10-11: Includuju <string.h> misto "block.h"
 */

char
num2char(byte num)
{
	return (num <= 10) ? num + '0' : num - 10 + 'A';
}

char *
ltostr(long num, char *string, signed short int max_chars, byte base)
#define dnum ((uint32)num)
{
	byte sign = 0;   /* number of digits occupied by the sign. */
	uint16 wbase = base & 0x3F;

	if ((base & 0x80))
		string[--max_chars] = '\0';

	if (num == 0) {
		string[--max_chars] = '0';
		max_chars--;
	}
	else {
		if (num < 0) {
			sign = 1;
			num = -num;
		}
		for (max_chars--; num && max_chars >= sign; max_chars --) {
			string[max_chars] = num2char(dnum % wbase);
			num = dnum / wbase;
		}
	}

	if (sign)
		string[max_chars--] = '-';

	if ( max_chars >= 0 )
		memset(string, base & 0x40 ? '0' : ' ', max_chars + 1);

	return string + max_chars + 1;
}
