#ifndef _P_NUM_X_X_H_
#define _P_NUM_X_X_H_
#include "globals.h"

/*
 * x_x cisla jsou uplne obycejna 32-bitova znamenkova cisla,
 * jediny rozdil je v tom jak se zobrazuji. Na displeji se totiz tvari jako
 * floaty, protoze se nekam doprostred vlozi desetinna tecka. Vsechny fce pro
 * praci s nimi berou jako jeden paramter cislo samotne, a jako druhy parametr
 * jeho specifikaci, ktera je nasledujici:
 * 8 bitu,
 * X X X X X X A S         I I I I F F F F
 *                          4 bity 4 bity
 * Priznak S urcuje, zda muze byt cislo zaporne (S = 1), 
 * nebo pouze kladne (S =0).
 * 
 * Priznak A urcuje, zda se pri vypisovani maji psat i nepotrebne nuly na 
 * konec (0.100 pro A = 1, 0.1  pro A = 0). 
 * 
 * I rika pocet cifer pred desetinnou carkou, F pocet cifer po desetinne 
 * carce.
 *
 * S desetinnou carkou ani se znamenkem se na displeji neda hybat, maji svoje
 * fixni pozice. Na pripadnou pozici znamenka (pouze u znamenkovych cisel)
 * se neda vepsat cifra.
 */

/* z definice (znamenkove, pocet celych cifer, pocet des. cifer) 
 * vytvori specifikaci */

#define X_X_SIGNED		0x100 /* priznak S */
#define X_X_ZEROS_AFTER	0x200 /* priznak A */

#define SPEC_X_X(FLAGS,INT,FRAC) ((FLAGS) | ((INT) << 4) | (FRAC))

/* Edituje x_x cislo */
char *
p_getnum_x_x(char *buf, word spec);

/* vraci -1 v pripade chyby, prevadi x_x cislo na int32 */
int32
str2num_x_x(const char *num, word spec);

/* Vytiskne x_x na obrazovku, na aktualni pozici */
void
p_put_x_x(int32 num, word spec);

#endif /* _P_NUM_X_X_H_ */
