/*
 * ava
 *
 * Power saving funkce
 *
 * Changelog
 *
 * 2006-09-14: Napsana tato hlavicka :-)
 */

#ifndef _SLEEP_H_
#define _SLEEP_H_

#include "globals.h"

 /**
  * enable_stop
  * pokud je true, v go_sleep() se zhasnutim displeje
  * (display_saving_timeout == 0) dojde k uvedeni
  * do stop modu (da se probudit klavesnici nebo resetem) */
extern volatile bool enable_stop;
 /**
  * sleeping
  * pred prechodem do stop modu se sleeping nastavi na true,
  * support int pak nemodifikuje klavesnicovou mrizku. */
extern volatile bool sleeping;


/**
 * go_sleep -- uvede procesor do sleep modu
 * ze sleep modu se da dostat interruptem
 */
void
go_sleep(void);

/**
 * go_stop -- uvede procesor do stop modu
 * ze stop modu se da dostat externim interruptem nebo hw resetem.
 * 
 * @param hiz -- pokud je true, vsechny vstupni nohy se uvedou do rezimu
 * vystupu ve vysoke impedanci (zarucuje minimalni odber)
 */
void
go_stop(bool hiz);

/**
 * set_pll
 * nastavi fazovy zaves, na 8Mhz krystalu pobezi procesor na 16ti Mhz.
 * cely to chvilku trva (2^13 taktu krystalu)
 * @param pll true -- nastavi fazovy zaves, false -- hlavni hodiny/2
 */
void 
set_pll(bool pll);

#endif /* _SLEEP_H_ */
