#ifndef _TABLE_H_
#define _TABLE_H_

#define TABLE_ADDR 1

#include "globals.h"
#include "globals.h"

#define TABLE_BIT_ALIVE (1 << 0)
#define TABLE_BIT_REFERENCED (1 << 1)
#define TABLE_BIT_BUSY (1 << 2)
#define TABLE_BIT_LOCAL (1 << 3)

/* Chybove kody stolu */
#define TABLE_ERR_OK 1
#define TABLE_ERR_BADPARAM 2
#define TABLE_ERR_END 3
#define TABLE_ERR_RANGE 4
#define TABLE_ERR_DIST 5
#define TABLE_ERR_POWER 6
#define TABLE_ERR_MOTORS 7
#define TABLE_ERR_POS 8
#define TABLE_ERR_MACRO 9
#define TABLE_ERR_STOP 10

#define TABLE_ERR_RECV 50
#define TABLE_ERR_SEND 51

#define TABLE_ERR_CMOS 90
#define TABLE_ERR_RAM 91
#define TABLE_ERR_ROM 92
#define TABLE_ERR_201 93
#define TABLE_ERR_301 94
#define TABLE_ERR_221 95
#define TABLE_ERR_311 96

/* Vraci cmd_ok, pokud byl stul nalezen, cmd_comm pokud ne. */
enum cmd_err
table_init(void);

enum cmd_err
table_get_id(char *str, size_t maxlen);

enum cmd_err
table_get_flags(uint32 *flags);

enum cmd_err
table_set_local(bool local);

enum cmd_err
table_goto(int32 x, int32 y);

enum cmd_err
table_kill(void);

enum cmd_err
table_get_pos(int32 *x, int32 *y);
	
enum cmd_err
table_set_zero(int32 x, int32 y);

enum cmd_err
table_get_zero(int32 *x, int32 *y);

enum cmd_err
table_go_reference(void);

enum cmd_err
table_invert(uint32 invert);

enum cmd_err
table_query(const char *q, char *buf, int maxlen);

enum cmd_err
table_get_last_error(uint32 *last_error);

#endif /* _TABLE_H_ */
