/*
 * ava
 *
 * uart, pouze inkludne verzi pro spravny OS
 *
 * Changelog
 *
 * 2006-09-14: Zalozeno
 * 2006-09-26: Oprava ser_purgebuf
 */

#include "globals.h"
#include "sleep.h"
#include "timer.h"

#ifdef __CKDM__
#include "uart-ckdm.c"
#endif

#ifdef __WIN32__
#include "uart-win32.c"
#endif

#ifdef __linux__
#include "uart-linux.c"
#endif

int 
ser_out_safe(byte kanal, const void *co, int kolik)
{
	while(ser_ostat(kanal)) {
		go_sleep();
	}
	ser_out(kanal, co, kolik);
	while(ser_ostat(kanal)) {
		go_sleep();
	}
	return 0;
}

